<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "gmb_data_point".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "GmbDataPoint".
 *
 * Columns in table "gmb_data_point" available as properties of the model,
 * followed by relations of table "gmb_data_point" available as properties of the model.
 *
 * @property integer $id
 * @property string $name
 * @property integer $allow_override
 *
 * @property ProviderPracticeGmbDataPoint[] $providerPracticeGmbDataPoints
 */
abstract class BaseGmbDataPoint extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'gmb_data_point';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'GmbDataPoint|GmbDataPoints', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('name', 'required'),
            array('allow_override', 'numerical', 'integerOnly'=>true),
            array('name', 'length', 'max'=>50),
            array('allow_override', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, name, allow_override', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'providerPracticeGmbDataPoints' => array(self::HAS_MANY, 'ProviderPracticeGmbDataPoint', 'gmb_data_point_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'allow_override' => Yii::t('app', 'Allow Override'),
            'providerPracticeGmbDataPoints' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('allow_override', $this->allow_override);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
